unit MainForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Vcl.Grids, Vcl.DBGrids, Vcl.StdCtrls,
  System.Generics.Collections, Aurelius.Drivers.Interfaces, Aurelius.Engine.DatabaseManager,
  Aurelius.Engine.ObjectManager, Aurelius.Bind.Dataset, Aurelius.Mapping.Attributes,
  Aurelius.SQL.SQLite, Aurelius.Schema.SQLite, Aurelius.Drivers.SQLite,
  VCLTee.Grid, VCLTee.Control;

type
  TForm1 = class(TForm)
    TeeGrid1: TTeeGrid;
    AureliusDataset1: TAureliusDataset;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    AureliusDataset2: TAureliusDataset;
    DataSource2: TDataSource;
    BNext: TButton;
    BPrevious: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BNextClick(Sender: TObject);
    procedure BPreviousClick(Sender: TObject);
  private
    FConnection: IDBConnection;
  public
    { Public declarations }
  end;

  type
  [Entity, Automapping]
  TContact = class
  private
    FId: Integer;
    FFirstName: string;
  public
    property Id: Integer read FId write FId;
    property FirstName: string read FFirstName write FFirstName;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.BNextClick(Sender: TObject);
begin
  if not AureliusDataset1.Eof then
     AureliusDataset1.Next;

  if not AureliusDataset2.Eof then
     AureliusDataset2.Next;
end;

procedure TForm1.BPreviousClick(Sender: TObject);
begin
  if AureliusDataset1.RecNo>1 then
     AureliusDataset1.Prior;

  if AureliusDataset2.RecNo>1 then
     AureliusDataset2.Prior;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
  Manager: TObjectManager;
  Contacts: TList<TContact>;
  Contact: TContact;
begin
  FConnection := TSQLiteNativeConnectionAdapter.Create(':memory:');
  TDatabaseManager.Update(FConnection);
  Manager := TObjectManager.Create(FConnection);
  for i:=1 to 25 do
  begin
    Contact:=TContact.Create;
    Contact.FirstName:='Name ' + IntToStr(i);
    Manager.Save(Contact);
  end;

  //TeeGrid
  DataSource1.DataSet:=AureliusDataset1;
  AureliusDataset1.CreateSelfField:=False;

  AureliusDataset1.Close;
  Contacts:=Manager.Find<TContact>.List;
  AureliusDataset1.SetSourceList(Contacts);
  AureliusDataset1.Manager:=Manager;
  AureliusDataset1.Open;

  TeeGrid1.DataSource:=DataSource1;
  TeeGrid1.Selected.Row:=0;
  TeeGrid1.Selected.Column:=TeeGrid1.Columns.Items[0];

  //DBGrid
  DBGrid1.DataSource:=DataSource2;
  DataSource2.DataSet:=AureliusDataset2;
  AureliusDataset2.CreateSelfField:=False;

  AureliusDataset2.Close;
  AureliusDataset2.SetSourceList(Contacts);
  AureliusDataset2.Manager:=Manager;
  AureliusDataset2.Open;
end;

end.
